<!DOCTYPE html>
<html lang="fr">

<head>
	<title>Afficheur de lapin</title>
	<meta charset="utf-8">
	<meta name="viewport"
		content="width=device-width, initial-scale=1.0, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
	<link rel="shortcut icon" type="image/jpg" href="favicon.jpg" />
	<style>
		body {
			color: #808080;
			font-family: Monospace;
			font-size: 13px;
			text-align: center;

			background-color: #fff;
			margin: 0px;
			overflow: hidden;
		}

		#info {
			position: absolute;
			top: 0px;
			width: 100%;
			padding: 5px;
		}

		a {
			color: #0080ff;
		}

		b {
			color: lightgreen;
		}
	</style>
</head>

<body>

	<div id="container"></div>
	<div id="info">Afficheur de maillage 3D<br />
		<b>Alt + Click gauche</b> ajouter un sommet au polygone <b>c</b> supprimer les sommets du polygone<br />
		<b>f</b> créer le polygone en passant par les faces <b>v</b> créer le polygone en passant par les sommets
	</div>


	<script src="js/treejs/three.min.js"></script>
	<script src="js/treejs/controls/TrackballControls.js"></script>
	<script src="js/treejs/loaders/PLYLoader.js"></script>

	<script src="js/treejs/loaders/ctm/lzma.js"></script>
	<script src="js/treejs/loaders/ctm/ctm.js"></script>
	<script src="js/treejs/loaders/ctm/CTMLoader.js"></script>

	<script src="js/geometry-processing-js/core/corner.js"></script>
	<script src="js/geometry-processing-js/core/discrete-exterior-calculus.js"></script>
	<script src="js/geometry-processing-js/core/edge.js"></script>
	<script src="js/geometry-processing-js/core/face.js"></script>
	<script src="js/geometry-processing-js/core/geometry.js"></script>
	<script src="js/geometry-processing-js/core/halfedge.js"></script>
	<script src="js/geometry-processing-js/core/mesh-subset.js"></script>
	<script src="js/geometry-processing-js/core/mesh.js"></script>
	<script src="js/geometry-processing-js/core/vertex.js"></script>
	<script src="js/geometry-processing-js/linear-algebra/vector.js"></script>

	<script>
		// from https://github.com/tcort/dijkstrajs
		var dijkstra = {
			single_source_shortest_paths: function (graph, s, d) {
				// Predecessor map for each node that has been encountered.
				// node ID => predecessor node ID
				var predecessors = {};

				// Costs of shortest paths from s to all nodes encountered.
				// node ID => cost
				var costs = {};
				costs[s] = 0;

				// Costs of shortest paths from s to all nodes encountered; differs from
				// `costs` in that it provides easy access to the node that currently has
				// the known shortest path from s.
				// XXX: Do we actually need both `costs` and `open`?
				var open = dijkstra.PriorityQueue.make();
				open.push(s, 0);

				var closest,
					u, v,
					cost_of_s_to_u,
					adjacent_nodes,
					cost_of_e,
					cost_of_s_to_u_plus_cost_of_e,
					cost_of_s_to_v,
					first_visit;
				while (!open.empty()) {
					// In the nodes remaining in graph that have a known cost from s,
					// find the node, u, that currently has the shortest path from s.
					closest = open.pop();
					u = closest.value;
					cost_of_s_to_u = closest.cost;

					// Get nodes adjacent to u...
					// adjacent_nodes = graph[u] || {};
					adjacent_nodes = graph.adjacent_nodes_of(u);

					// ...and explore the edges that connect u to those nodes, updating
					// the cost of the shortest paths to any or all of those nodes as
					// necessary. v is the node across the current edge from u.
					for (v in adjacent_nodes) {
						if (adjacent_nodes.hasOwnProperty(v)) {
							// Get the cost of the edge running from u to v.
							cost_of_e = adjacent_nodes[v];

							// Cost of s to u plus the cost of u to v across e--this is *a*
							// cost from s to v that may or may not be less than the current
							// known cost to v.
							cost_of_s_to_u_plus_cost_of_e = cost_of_s_to_u + cost_of_e;

							// If we haven't visited v yet OR if the current known cost from s to
							// v is greater than the new cost we just found (cost of s to u plus
							// cost of u to v across e), update v's cost in the cost list and
							// update v's predecessor in the predecessor list (it's now u).
							cost_of_s_to_v = costs[v];
							first_visit = (typeof costs[v] === 'undefined');
							if (first_visit || cost_of_s_to_v > cost_of_s_to_u_plus_cost_of_e) {
								costs[v] = cost_of_s_to_u_plus_cost_of_e;
								open.push(v, cost_of_s_to_u_plus_cost_of_e);
								predecessors[v] = u;
							}
						}
					}
				}

				if (typeof d !== 'undefined' && typeof costs[d] === 'undefined') {
					var msg = ['Could not find a path from ', s, ' to ', d, '.'].join('');
					throw new Error(msg);
				}

				return predecessors;
			},

			extract_shortest_path_from_predecessor_list: function (predecessors, d) {
				var nodes = [];
				var u = d;
				var predecessor;
				while (u) {
					nodes.push(u);
					predecessor = predecessors[u];
					u = predecessors[u];
				}
				nodes.reverse();
				return nodes;
			},

			find_path: function (graph, s, d) {
				var predecessors = dijkstra.single_source_shortest_paths(graph, s, d);
				return dijkstra.extract_shortest_path_from_predecessor_list(
					predecessors, d);
			},

			/**
			 * A very naive priority queue implementation.
			 */
			PriorityQueue: {
				make: function (opts) {
					var T = dijkstra.PriorityQueue,
						t = {},
						key;
					opts = opts || {};
					for (key in T) {
						if (T.hasOwnProperty(key)) {
							t[key] = T[key];
						}
					}
					t.queue = [];
					t.sorter = opts.sorter || T.default_sorter;
					return t;
				},

				default_sorter: function (a, b) {
					return a.cost - b.cost;
				},

				/**
				 * Add a new item to the queue and ensure the highest priority element
				 * is at the front of the queue.
				 */
				push: function (value, cost) {
					var item = { value: value, cost: cost };
					this.queue.push(item);
					this.queue.sort(this.sorter);
				},

				/**
				 * Return the highest priority element in the queue.
				 */
				pop: function () {
					return this.queue.shift();
				},

				empty: function () {
					return this.queue.length === 0;
				}
			}
		};

		//Vérification des possibilités WebGL
		// if ( ! Detector.webgl ) Detector.addGetWebGLMessage();

		var container;
		var camera, scene, renderer;
		var tjMesh, gpGeometry;
		//theShadowLight;
		var windowHalfX = window.innerWidth / 2;
		var windowHalfY = window.innerHeight / 2;

		var userPoly = [];

		const raycaster = new THREE.Raycaster();
		const mouse = new THREE.Vector2();

		var graph_gp_geo_face = {
			adjacent_nodes_of: function (fI) {
				let f = gpGeometry.mesh.faces[fI];
				var f_centroid = gpGeometry.centroid(f);
				var adj = new Object;
				for (let n of f.adjacentFaces()) {
					adj[n.index] = f_centroid.minus(gpGeometry.centroid(n)).norm2();
				}
				return adj;
			}
		};

		var graph_gp_geo_vertex = {
			adjacent_nodes_of: function (vI) {
				let v = gpGeometry.mesh.vertices[vI];
				var v_pos = gpGeometry.positions[vI];
				var adj = new Object;
				for (let n of v.adjacentVertices()) {
					adj[n.index] = v_pos.minus(gpGeometry.positions[n.index]).norm2();
				}
				return adj;
			}
		};

		//Lancement du rendu
		init();
		animate();

		function init() {

			container = document.getElementById('container');

			var canvas = document.createElement('canvas');
			canvas.width = 128;
			canvas.height = 128;

			var context = canvas.getContext('2d');
			context.fillRect(0, 0, canvas.width, canvas.height);

			var lightBox = 3.0;

			renderer = new THREE.WebGLRenderer({ antialias: true });
			renderer.setClearColor(0xffffff);
			renderer.setPixelRatio(window.devicePixelRatio);
			renderer.setSize(window.innerWidth, window.innerHeight);

			//Caméra
			camera = new THREE.PerspectiveCamera(35, window.innerWidth / window.innerHeight, 0.1, 10000);
			camera.position.z = lightBox;
			cameraTarget = new THREE.Vector3(0, 0, 0);

			//Contrôles
			controls = new THREE.TrackballControls(camera);
			controls.rotateSpeed = 5.0;
			controls.zoomSpeed = 1;
			controls.panSpeed = 1;

			controls.noZoom = false;
			controls.noPan = false;

			controls.staticMoving = true;
			controls.dynamicDampingFactor = 0.3;

			//Création de la scène
			scene = new THREE.Scene();

			//Mise en place d'une lumière ambiente
			scene.add(new THREE.AmbientLight(0xffffff));
			var myLightPos = new THREE.Vector3(0, 0, 0);


			//fichier source du maillage, SUZANNE.PLY, loader ply
			var sourcePLY = 'data/bunny.ply'
			console.log("viewMesh Ply : " + sourcePLY);

			var loaderPLY = new THREE.PLYLoader();

			loaderPLY.load(sourcePLY, function (geometryPLY) {
				var tree_geo = new THREE.Geometry();
				tree_geo.fromBufferGeometry(geometryPLY);
				tree_geo.mergeVertices();
				tree_geo.normalize();

				geometryPLY.computeFaceNormals();
				geometryPLY.computeVertexNormals();

				var materialPLY = new THREE.MeshLambertMaterial({ color: 0x444444, vertexColors: THREE.FaceColors });
				materialPLY.polygonOffset = true;
				materialPLY.depthTest = true;
				materialPLY.polygonOffsetFactor = 1;
				materialPLY.polygonOffsetUnits = 0.1;

				tjMesh = new THREE.Mesh(tree_geo, materialPLY);
				tjMesh.castShadow = true;
				tjMesh.receiveShadow = true;
				scene.add(tjMesh);

				var w_geo = new THREE.WireframeGeometry(tree_geo)
				var w_mat = new THREE.LineBasicMaterial({ color: 0xeeeeee, linewidth: 1 });
				var wireframe = new THREE.LineSegments(w_geo, w_mat);
				scene.add(wireframe);

				var positions = [];
				for (const v of tree_geo.vertices) {
					positions.push(new Vector(v.x, v.y, v.z));
				}

				var faces = [];
				for (const f of tree_geo.faces) {
					faces.push(f.a);
					faces.push(f.b);
					faces.push(f.c);
				}

				var polygonSoup = new Object;
				polygonSoup["v"] = positions;
				polygonSoup["f"] = faces;

				var mesh = new Mesh();
				mesh.build(polygonSoup);

				var geo = new Geometry(mesh, positions, false);
				gpGeometry = geo;
			});

			//fichier source du maillage, STATUES.CTM, loader ctm
			/*var sourceCTM = 'data/statues.ctm'
			console.log("viewMesh CTM : "+sourceCTM);

			var loaderCTM = new THREE.CTMLoader();

			loaderCTM.load(sourceCTM, function ( geometryCTM ) {

				geometryCTM.computeFaceNormals();
					geometryCTM.computeVertexNormals();
					geometryCTM.computeBoundingBox();

				var centreCTM = new THREE.Vector3();
					centreCTM.x = ( geometryCTM.boundingBox.max.x + geometryCTM.boundingBox.min.x ) / 2.0;
					centreCTM.y = ( geometryCTM.boundingBox.max.y + geometryCTM.boundingBox.min.y ) / 2.0;
					centreCTM.z = ( geometryCTM.boundingBox.max.z + geometryCTM.boundingBox.min.z ) / 2.0;

				geometryCTM.computeBoundingSphere();

				var materialCTM = new THREE.MeshLambertMaterial({color: 0x443322 } );

				var meshCTM = new THREE.Mesh( geometryCTM, materialCTM );
					meshCTM.position.set( -centreCTM.x, -centreCTM.y, -centreCTM.z);
					meshCTM.castShadow = true;
					meshCTM.receiveShadow = true;

				myLightPos.x = 1.1 * geometryCTM.boundingBox.max.x;
				myLightPos.y = 1.1 * geometryCTM.boundingBox.max.y;
				myLightPos.z = 1.1 * geometryCTM.boundingBox.max.z;

				scene.add( meshCTM );
			});*/

			//une lumière supplémentaire
			var myLight = new THREE.SpotLight(0xffffff);
			myLight.castShadow = false;            // default false
			myLight.position.set(myLightPos.x, myLightPos.y, myLightPos.z);
			scene.add(myLight);

			//gestion des ombres
			renderer.shadowMap.enabled = true;
			//renderer.shadowMap.cullFace = THREE.CullFaceFront;//deprecated in v89
			//renderer.shadowMap.renderReverseSided = true; //v89 deprecated in v97
			renderer.shadowMap.type = THREE.PCFSoftShadowMap; // default THREE.PCFShadowMap

			//un spotLight pour les ombres
			var lightShadow = new THREE.SpotLight(0xffffff);
			lightShadow.castShadow = true;            // default false
			scene.add(lightShadow);

			//les paramètres du spotlight des ombres
			lightShadow.shadow.mapSize.width = 512;  // default (cf doc ThreeJS.org)
			lightShadow.shadow.mapSize.height = 512; // default
			lightShadow.shadow.camera.near = 0.5;       // default
			lightShadow.shadow.camera.far = 500      // default
			lightShadow.position.set(camera.position.x, camera.position.y, camera.position.z);

			container.appendChild(renderer.domElement);

			container.addEventListener('click', onClick, false);
			document.addEventListener('keydown', onKeyDown, false);

			window.addEventListener('resize', onWindowResize, false);
		}

		function onWindowResize() {
			windowHalfX = window.innerWidth / 2;
			windowHalfY = window.innerHeight / 2;

			camera.aspect = window.innerWidth / window.innerHeight;
			camera.updateProjectionMatrix();

			renderer.setSize(window.innerWidth, window.innerHeight);
		}

		function animate() {
			requestAnimationFrame(animate);
			controls.update();

			render();
		}

		function render() {

			renderer.render(scene, camera);
		}

		function onClick(event) {
			if (!event.altKey) return;

			mouse.x = (event.clientX / renderer.domElement.clientWidth) * 2 - 1;
			mouse.y = - (event.clientY / renderer.domElement.clientHeight) * 2 + 1;
			raycaster.setFromCamera(mouse, camera);

			// See if the ray from the camera into the world hits one of our meshes
			const intersects = raycaster.intersectObject(tjMesh);

			// Toggle rotation bool for meshes that we clicked
			if (intersects.length > 0) {
				let inter = new Object;
				inter.faceIndex = intersects[0].faceIndex;
				inter.point = intersects[0].point;
				userPoly.push(inter);
				showUserPoly()
			}
		}

		function onKeyDown(event) {
			if (event.key == "c") {
				userPoly.length = 0;
				showUserPoly();
				resetMaterial();
			}

			if (event.key == "f") {
				makeUserPolyFace();
			}

			if (event.key == "v") {
				makeUserPolyVertex();
			}
		}

		function showUserPoly() {
			let points = [];

			for (let i of userPoly) {
				points.push(new THREE.Vector3(i.point.x, i.point.y, i.point.z));
			}

			showRedPoints(points);
		}

		function resetMaterial() {
			for (let f of tjMesh.geometry.faces) {
				f.color.setRGB(1, 1, 1);
			}
			tjMesh.geometry.colorsNeedUpdate = true;

			if (lastPolyVertexLine != null) {
				scene.remove(lastPolyVertexLine);
				lastPolyVertexLine = null;
			}
		}

		function makeUserPolyFace() {
			resetMaterial();

			for (let i = 0; i < userPoly.length; i++) {
				let j = (i + 1) % userPoly.length;

				let path = dijkstra.find_path(graph_gp_geo_face, userPoly[i].faceIndex, userPoly[j].faceIndex);
				for (let i of path) {
					tjMesh.geometry.faces[i].color.setRGB(0, 0, 2);
				}
			}

			tjMesh.geometry.colorsNeedUpdate = true;
		}

		function colsestVertex(point, faceIndex) {
			let f = gpGeometry.mesh.faces[faceIndex];
			let min_norm = Number.MAX_VALUE;
			let min_vert = null;
			for (let v of f.adjacentVertices()) {
				let norm = point.distanceToSquared(gpGeometry.positions[v.index]);
				if (norm > min_norm) continue;
				min_norm = norm;
				min_vert = v.index;
			}
			return min_vert;
		}

		var lastPolyVertexLine = null;
		function makeUserPolyVertex() {
			resetMaterial();

			let userPolyVertices = [];
			for (let i = 0; i < userPoly.length; i++) {
				userPolyVertices.push(colsestVertex(userPoly[i].point, userPoly[i].faceIndex));
			}

			let points = [];
			for (let i = 0; i < userPoly.length; i++) {
				let j = (i + 1) % userPoly.length;

				var path = dijkstra.find_path(graph_gp_geo_vertex, userPolyVertices[i], userPolyVertices[j]);
				for (let i of path) {
					let pos = gpGeometry.positions[i];
					points.push(new THREE.Vector3(pos.x, pos.y, pos.z));
				}
			}

			let geo = new THREE.BufferGeometry().setFromPoints(points);
			let mat = new THREE.LineBasicMaterial({ color: 0x0000ff, linewidth: 1 });
			lastPolyVertexLine = new THREE.Line(geo, mat);
			scene.add(lastPolyVertexLine);
		}

		const tloader = new THREE.TextureLoader();
		const tdisc = tloader.load('data/disc.png');

		var lastRedPoints = null;
		function showRedPoints(points) {
			const pointsMaterial = new THREE.PointsMaterial({
				color: 0xff0000,
				map: tdisc,
				size: 0.05,
				alphaTest: 0.5
			});

			const pointsGeometry = new THREE.BufferGeometry().setFromPoints(points);

			if (lastRedPoints != null) {
				scene.remove(lastRedPoints);
				lastRedPoints = null;
			}
			lastRedPoints = new THREE.Points(pointsGeometry, pointsMaterial);
			scene.add(lastRedPoints);
		}

	</script>
</body>

</html>